## mingw-w64-tfel-5.1.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
cmake_policy(SET CMP0022 NEW)
cmake_policy(SET CMP0054 NEW)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30.0)
  cmake_policy(SET CMP0167 NEW)  
endif(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30.0)
if(CMAKE_VERSION VERSION_GREATER 3.14.0)
  cmake_policy(SET CMP0083 NEW)  
  include(CheckPIESupported)
  check_pie_supported()
endif(CMAKE_VERSION VERSION_GREATER 3.14.0)

set(TFEL_VERSION_FLAVOUR "" CACHE STRING
  "Append a flavour to the version number")
option(TFEL_APPEND_VERSION
  "append TFEL version number to all libraries, executables and directories" OFF)

option(BUILD_SHARED_LIBS  "enable shared libraries" ON)
if(NOT BUILD_SHARED_LIBS)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  # when BUILD_SHARED_LIBS=OFF then disable option enable-static
  set(enable-static OFF CACHE BOOL "enable additional static libraries" FORCE)
endif()

if(EXISTS "${PROJECT_BINARY_DIR}/conanbuildinfo.cmake")
  include(${PROJECT_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup(NO_OUTPUT_DIRS)
  set(TFEL_USES_CONAN ON)
endif(EXISTS "${PROJECT_BINARY_DIR}/conanbuildinfo.cmake")

set(CMAKE_CXX_STANDARD 20)
set(CXX_STANDARD_REQUIRED ON)

# tfel specific macros
include(cmake/modules/tfel.cmake)
# some variables for compatibility with autotools
include(cmake/modules/autotools.cmake)

#major and minor version
set(TFEL_DEVELOPMENT_VERSION OFF)
tfel_project(5 1 "0")
set(PACKAGE_BUGREPORT "tfel-contact@cea.fr")

# load the list of rounding modes defined by the IEEE754 standard
include(cmake/modules/ieee754.cmake)

# check for the fenv package
option(enable-use-fenv "enable usage of the fenv package" ON)
if(enable-use-fenv)
include(CheckIncludeFiles)
check_include_files(fenv.h HAVE_FENV_H)
if(HAVE_FENV_H)
  tfel_add_c_cxx_definitions("HAVE_FENV")
endif(HAVE_FENV_H)
endif(enable-use-fenv)
  
option(enable-include-what-you-use
  "enable include-what-you-use diagnostics" OFF)
if(enable-include-what-you-use)
  find_program(TFEL_IWYU_PATH NAMES include-what-you-use iwyu)
  if(NOT TFEL_IWYU_PATH)
    message(FATAL_ERROR "could not find the program include-what-you-use")
  endif()
endif(enable-include-what-you-use)

find_package(Threads)

if(UNIX)
  if(NOT TFEL_DL_LIBRARY)
    # This is used in mtest tests files
    set(TFEL_LOCAL_LIBRARY_PREFIX "./")
    # Looking for libdl...
    if((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      find_library(TFEL_DL_LIBRARY
	NAMES dl)
      if(NOT TFEL_DL_LIBRARY)
	MESSAGE(FATAL_ERROR "the libdl library not found. You may want to set the `TFEL_DL_LIBRARY` manually")
      endif(NOT TFEL_DL_LIBRARY)
    else((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      set(TFEL_DL_LIBRARY "")
    endif((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
      (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
  endif(NOT TFEL_DL_LIBRARY)
else(UNIX)
  set(TFEL_LOCAL_LIBRARY_PREFIX "")
  set(TFEL_DL_LIBRARY "")
endif(UNIX)

# adding support for rpath on MacOs X
if(APPLE)
   set(CMAKE_MACOSX_RPATH ON)
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
   list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
   if("${isSystemDir}" STREQUAL "-1")
      set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   endif()
endif()

#extraction git hash
if(NOT TFEL_GIT_HASH)
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE TFEL_GIT_HASH
  OUTPUT_STRIP_TRAILING_WHITESPACE)
message("Abbreviated commit hash: ${TFEL_GIT_HASH}")
endif(NOT TFEL_GIT_HASH)
tfel_add_c_cxx_definitions("TFEL_GIT_HASH=\"${TFEL_GIT_HASH}\"")
tfel_add_c_cxx_definitions("TFEL_CMAKE_GENERATOR=\"${CMAKE_GENERATOR}\"")

# testing
set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")
# (must be placed *before* any add_subdirectory, cmake bug ?)
option(enable-testing "enable tests" ON)
option(enable-mfront-quantity-tests "enable tests of behaviours using quantities (such tests fails on old compilers)" ON)
if(enable-testing)
  enable_testing()
  if(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test -C $<CONFIGURATION>)
  else(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test )
  endif(CMAKE_CONFIGURATION_TYPES)
endif()

option(enable-cppcheck "analyse targets with cppcheck" OFF)
if(enable-cppcheck)
  message(STATUS "cppcheck support enabled")
  set(HAVE_CPPCHECK ON)
  include(cmake/modules/FindCppCheck.cmake)
  include(cmake/modules/CppCheckTargets.cmake)
endif(enable-cppcheck)

option(enable-vera++ "analyse targets with vera++" OFF)
if(enable-vera++)
  message(STATUS "vera++ support enabled")
  find_package(vera++)
  include(${VERA++_USE_FILE})
  if(NOT VERA_ROOT)
    message(fatal "VERA_ROOT is not defined")
  endif(NOT VERA_ROOT)
  add_vera_targets(*.h *.cpp
    RECURSE
    ROOT "${VERA_ROOT}/lib/vera++")
endif(enable-vera++)

# floatting point exceptions (TODO)

# portable-build
option(enable-portable-build "produce binary that can be shared between various machine (same architecture, same gcc version, different processors" OFF)

# madnex
option(enable-madnex "enable madnex file support in mfront (see https://github.com/thelfer/madnex)" OFF)
if(enable-madnex)
  find_package(Madnex REQUIRED)
  set(TFEL_HAVE_MADNEX ON)
endif(enable-madnex)

# fortran (placed before compiler detection)
option(enable-fortran "enable fortran support" OFF)
if(enable-fortran)
  set(HAVE_FORTRAN ON)
  tfel_add_c_cxx_definitions("HAVE_FORTRAN=1")
  enable_language (Fortran)
  message(STATUS "fortran support enabled")
  set(enable-fortran-bindings ON)
else(enable-fortran)
  set(HAVE_FORTRAN OFF)
  message(STATUS "fortran support disabled")
  set(enable-fortran-bindings OFF)
endif(enable-fortran)

#compiler options
include(cmake/modules/compiler.cmake)
if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  include(cmake/modules/CodeCoverage.cmake)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
endif(CMAKE_BUILD_TYPE STREQUAL "Coverage")

#aster
option(enable-aster "build aster interface for mechanical behaviours" OFF)
if(enable-aster)
  message(STATUS "aster support enabled")
  set(HAVE_ASTER ON)
  tfel_add_c_cxx_definitions("HAVE_ASTER=1")
  include(cmake/modules/aster.cmake)
endif(enable-aster)

#abaqus
option(enable-abaqus "build abaqus interface for mechanical behaviours" OFF)
if(enable-abaqus)
  message(STATUS "abaqus support enabled")
  set(HAVE_ABAQUS ON)
  tfel_add_c_cxx_definitions("HAVE_ABAQUS=1")
endif(enable-abaqus)

# LS-DYNA
option(enable-lsdyna "build lsdyna interface for mechanical behaviours" OFF)
if(enable-lsdyna)
  message(STATUS "lsdyna support enabled")
  set(HAVE_LSDYNA ON)
  tfel_add_c_cxx_definitions("HAVE_LSDYNA=1")
endif(enable-lsdyna)

#diana-fea
option(enable-diana-fea "build Diana FEA interface for mechanical behaviours" OFF)
if(enable-diana-fea)
  message(STATUS "Diana FEA support enabled")
  set(HAVE_DIANAFEA ON)
  tfel_add_c_cxx_definitions("HAVE_DIANAFEA=1")
endif(enable-diana-fea)

#calculix
option(enable-calculix "build CalculiX interface for mechanical behaviours" OFF)
if(enable-calculix)
  message(STATUS "CalculiX support enabled")
  set(HAVE_CALCULIX ON)
  tfel_add_c_cxx_definitions("HAVE_CALCULIX=1")
endif(enable-calculix)

#ansys
option(enable-ansys "build ansys interface for mechanical behaviours" OFF)
if(enable-ansys)
  message(STATUS "ansys support enabled")
  set(HAVE_ANSYS ON)
  tfel_add_c_cxx_definitions("HAVE_ANSYS=1")
endif(enable-ansys)

#zmat
option(enable-zmat "build zmat interface for mechanical behaviours" OFF)
if(enable-zmat)
  include(cmake/modules/zset.cmake)
  message(STATUS "zmat support enabled")
  set(HAVE_ZMAT ON)
  tfel_add_c_cxx_definitions("HAVE_ZMAT=1")
endif(enable-zmat)

#cyrano
include(cmake/modules/cyrano.cmake)
option(enable-cyrano "build cyrano interface for mechanical behaviours" OFF)
if(enable-cyrano)
  message(STATUS "cyrano support enabled")
  set(HAVE_CYRANO ON)
  tfel_add_c_cxx_definitions("HAVE_CYRANO=1")
endif(enable-cyrano)

#castem
include(cmake/modules/castem-unix-type.cmake)
option(local-castem-header    "use a local version of castem.h"  OFF)
option(enable-castem-pleiades "use a pleiades version of castem" OFF)
if(local-castem-header)
  tfel_add_c_cxx_definitions("LOCAL_CASTEM_HEADER=1")
  tfel_add_c_cxx_definitions("HAVE_CASTEM=1")
  set(HAVE_CASTEM ON)
  set(LOCAL_CASTEM_HEADER ON)
else(local-castem-header)
  include(cmake/modules/castem.cmake)
endif(local-castem-header)

# comsol
option(enable-comsol "build Comsol interface for mechanical behaviours" OFF)
if(enable-comsol)
  message(STATUS "Comsol support enabled")
  set(HAVE_COMSOL ON)
  tfel_add_c_cxx_definitions("HAVE_COMSOL=1")
endif(enable-comsol)

#gnuplot
include(FindGnuplot)
if(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT ON)
  tfel_add_c_cxx_definitions("HAVE_GNUPLOT=1")
  tfel_add_c_cxx_definitions("GNUPLOT_PATH=\"${GNUPLOT_EXECUTABLE}\"")
  message(STATUS "found gnuplot")
  message(STATUS "gnuplot path ${GNUPLOT_EXECUTABLE}")
else(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT OFF)
endif(GNUPLOT_FOUND)

#python
option(enable-python "enable python support" OFF)
option(enable-python-bindings "enable  python bindings support" OFF)
option(unversioned-python-module-names
"if enabled, do not reflect the version and flavour information. \
This option has no effect if the python bindings are not enabled and if none \
TFEL_APPEND_VERSION or TFEL_VERSION_FLAVOUR variables is set " OFF)
option(enable-numpy-support
  "enable numpy support. This option has no effect if python bindings are disabled" ON)
 
if(enable-python OR enable-python-bindings)
  if(enable-numpy-support)
    find_package(Python REQUIRED COMPONENTS Interpreter Development NumPy)
  else()
    find_package(Python REQUIRED COMPONENTS Interpreter Development)
  endif()
  set(HAVE_PYTHON ON)
  tfel_add_c_cxx_definitions("HAVE_PYTHON=1")
  tfel_add_c_cxx_definitions("TFEL_PYTHON_INCLUDES=\"-I${Python_INCLUDE_DIRS}\"")
  get_filename_component(PYTHON_LIBRARY_PATH ${Python_LIBRARIES} PATH)
  get_filename_component(PYTHON_LIBRARY_FULL ${Python_LIBRARIES} NAME)
  string(REGEX REPLACE "lib(.+)\\.(.+)$" "\\1" PYTHON_LIBRARY ${PYTHON_LIBRARY_FULL})
  tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBRARY_PATH=\"${PYTHON_LIBRARY_PATH}\"")
  tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBRARY=\"${PYTHON_LIBRARY}\"")
  if(MSVC)
    tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBS=\"${PYTHON_LIBRARY_PATH}\${PYTHON_LIBRARY}\"")
  else(MSVC)
    tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBS=\"-L${PYTHON_LIBRARY_PATH} -l${PYTHON_LIBRARY}\"")
  endif(MSVC) 
  message(STATUS "found python          ${Python_VERSION}")
  message(STATUS "python include path   ${Python_INCLUDE_DIRS}")
  message(STATUS "python libraries path ${PYTHON_LIBRARY_PATH}")
  message(STATUS "python library        ${PYTHON_LIBRARY}")
  message(STATUS "python interpreter    ${Python_EXECUTABLE}")
  if(NOT TFEL_PYTHON_SITE_PACKAGES_DIR)
    if(WIN32)
      set(TFEL_PYTHON_SITE_PACKAGES_DIR "bin/python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages")
    else(WIN32)
      set(TFEL_PYTHON_SITE_PACKAGES_DIR "lib${LIB_SUFFIX}/python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages")
    endif(WIN32)
  endif(NOT TFEL_PYTHON_SITE_PACKAGES_DIR)
  if(enable-numpy-support)
    message(STATUS "Numpy version         ${Python_NumPy_VERSION}")
    message(STATUS "Numpy header path     ${Python_NumPy_INCLUDE_DIRS}")
  endif(enable-numpy-support)
endif(enable-python OR enable-python-bindings)

#some checks
if(enable-python)
  if(NOT HAVE_PYTHON)
    message(FATAL_ERROR "python not found. python is mandatory for python suppot.")
  endif(NOT HAVE_PYTHON)
endif(enable-python)

#python bindings
if(enable-python-bindings)
  include(cmake/modules/tfel-python-modules.cmake)
  if(NOT HAVE_PYTHON)

=== docs/mfront/CMakeLists.txt ===
macro(install_mfront_desc file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md DESTINATION share/doc/mfront
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc file)

macro(install_mfront_desc2 directory file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${directory}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${directory}/${file}.md
      DESTINATION share/doc/mfront/${directory}
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc2 directory file)

macro(install_mfront_desc3 directory1 directory2 file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory1}
      COMPONENT mfront)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory2}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront/${directory1}
      COMPONENT mfront)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront/${directory2}
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc3 directory file)

install_mfront_desc(AdditionalConvergenceChecks)
install_mfront_desc(AdditionalTangentOperatorBlock)
install_mfront_desc(AdditionalTangentOperatorBlocks)
install_mfront_desc(Algorithm)
install_mfront_desc(Author)
install_mfront_desc(AuxiliaryModel)
install_mfront_desc(AuxiliaryStateVar)
install_mfront_desc(AuxiliaryStateVariable)
install_mfront_desc(AxialGrowth)
install_mfront_desc(Behaviour)
install_mfront_desc(BehaviourVariable)
install_mfront_desc(BehaviourVariableFactory)
install_mfront_desc(Bounds)
install_mfront_desc(Brick)
install_mfront_desc(Coef)
install_mfront_desc(ComputeFinalStress)
install_mfront_desc(ComputeStiffnessTensor)
install_mfront_desc(ComputeStressFreeExpansion)
install_mfront_desc(ComputeStress)
install_mfront_desc(ComputeThermalExpansion)
install_mfront_desc(CompareToNumericalJacobian)
install_mfront_desc(CrystalStructure)
install_mfront_desc(Date)
install_mfront_desc(Description)
install_mfront_desc(DislocationsMeanFreePathInteractionMatrix)
install_mfront_desc(DissipatedEnergy)
install_mfront_desc(DSL)
install_mfront_desc(ElasticMaterialProperties)
install_mfront_desc(Epsilon)
install_mfront_desc(ExternalStateVar)
install_mfront_desc(ExternalStateVariable)
install_mfront_desc(GlidingSystem)
install_mfront_desc(GlidingSystems)
install_mfront_desc(Import)
install_mfront_desc(InitializeJacobian)
install_mfront_desc(InitializeJacobianInvert)
install_mfront_desc(InitJacobian)
install_mfront_desc(InitJacobianInvert)
install_mfront_desc(Includes)
install_mfront_desc(InteractionMatrix)
install_mfront_desc(IntegrationVariable)
install_mfront_desc(Interface)
install_mfront_desc(InternalEnergy)
install_mfront_desc(InitLocalVars)
install_mfront_desc(InitLocalVariables)
install_mfront_desc(InitializeLocalVariables)
install_mfront_desc(InitializeFunction)
install_mfront_desc(InitializeFunctionVariable)
install_mfront_desc(IsotropicBehaviour)
install_mfront_desc(IsotropicElasticBehaviour)
install_mfront_desc(IsotropicHardeningRule)
install_mfront_desc(IsotropicHardeningRules)
install_mfront_desc(IterMax)
install_mfront_desc(JacobianComparisonCriterion)
install_mfront_desc(JacobianComparisonCriterium)
install_mfront_desc(Library)
install_mfront_desc(Link)
install_mfront_desc(LocalVar)
install_mfront_desc(Material)
install_mfront_desc(MaterialLaw)
install_mfront_desc(MaterialProperty)
install_mfront_desc(MaximumNumberOfIterations)
install_mfront_desc(MaximalTimeStepScalingFactor)
install_mfront_desc(MinimalTimeStepScalingFactor)
install_mfront_desc(Model)
install_mfront_desc(NumericallyComputedJacobianBlocks)
install_mfront_desc(OrthotropicBehaviour)
install_mfront_desc(Parameter)
install_mfront_desc(Parser)
install_mfront_desc(PerturbationValueForNumericalJacobianComputation)
install_mfront_desc(PhysicalBounds)
install_mfront_desc(PostProcessing)
install_mfront_desc(PostProcessingVariable)
install_mfront_desc(ProcessNewCorrection)
install_mfront_desc(ProcessNewEstimate)
install_mfront_desc(Private)
install_mfront_desc(Profiling)
install_mfront_desc(Relocation)
install_mfront_desc(RejectCurrentCorrection)
install_mfront_desc(RequireStiffnessOperator)
install_mfront_desc(RequireStiffnessTensor)
install_mfront_desc(RequireThermalExpansionCoefficientTensor)
install_mfront_desc(SlidingSystem)
install_mfront_desc(SlidingSystems)
install_mfront_desc(SlipSystem)
install_mfront_desc(SlipSystems)
install_mfront_desc(Sources)
install_mfront_desc(SpeedOfSound)
install_mfront_desc(StateVar)
install_mfront_desc(StateVariable)
install_mfront_desc(StaticVar)
install_mfront_desc(StaticVariable)
install_mfront_desc(StrainMeasure)
install_mfront_desc(Swelling)
install_mfront_desc(TangentOperator)
install_mfront_desc(TangentOperatorBlock)
install_mfront_desc(TangentOperatorBlocks)
install_mfront_desc(Theta)
install_mfront_desc(UnitSystem)
install_mfront_desc(UpdateAuxiliaryStateVars)
install_mfront_desc(UpdateAuxiliaryStateVariables)
install_mfront_desc(UsableInPurelyImplicitResolution)
install_mfront_desc(UseQt)

install_mfront_desc2(Implicit HillTensor)

install_mfront_desc3(MaterialLaw MaterialProperty Constant)
install_mfront_desc3(MaterialLaw MaterialProperty Data)
install_mfront_desc3(MaterialLaw MaterialProperty Function)
install_mfront_desc3(MaterialLaw MaterialProperty Input)
install_mfront_desc3(MaterialLaw MaterialProperty Law)
install_mfront_desc3(MaterialLaw MaterialProperty MFront)
install_mfront_desc3(MaterialLaw MaterialProperty Output)

install_mfront_desc2(Model ConstantMaterialProperty)
install_mfront_desc2(Model Domain)
install_mfront_desc2(Model Domains)
install_mfront_desc2(Model Function)
install_mfront_desc2(Model Input)
install_mfront_desc2(Model Integrator)
install_mfront_desc2(Model GlobalParameter)
install_mfront_desc2(Model LocalParameter)
install_mfront_desc2(Model Model)
install_mfront_desc2(Model Output)
install_mfront_desc2(Default Integrator)
install_mfront_desc2(ImplicitGenericBehaviour Integrator)
install_mfront_desc2(DefaultCZM Integrator)
install_mfront_desc2(DefaultGenericBehaviour Integrator)
install_mfront_desc2(Implicit Integrator)
install_mfront_desc2(ImplicitFiniteStrain Integrator)
install_mfront_desc2(ImplicitII Integrator)
install_mfront_desc2(Model Integrator)
install_mfront_desc2(ImplicitCZM Integrator)
install_mfront_desc2(DefaultFiniteStrain Integrator)

install_mfront_desc2(bricks StandardElasticity)
install_mfront_desc2(bricks DDIF2)

install_mfront_desc2(stress-potentials Hooke)
install_mfront_desc2(stress-potentials DDIF2)

if(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

  configure_file(glossary.tex.in
    glossary.tex @ONLY)
  add_subdirectory(general)
  add_subdirectory(behaviours)
  add_subdirectory(finitestrain)
  add_subdirectory(planestress)
  add_subdirectory(castem)
  add_subdirectory(aster)
  add_subdirectory(zmat)

endif(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

add_subdirectory(abaqus)
add_subdirectory(dianafea)
add_subdirectory(ansys)
add_subdirectory(lsdyna)

=== docs/web/CMakeLists.txt ===
macro(pandoc_html file)
  ADD_CUSTOM_COMMAND(
    OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/mfront-template.html
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/css/main.css
    COMMAND   ${PANDOC}
    ARGS      -f markdown-markdown_in_html_blocks+tex_math_single_backslash+grid_tables
    ARGS      --filter ${PANDOC_REFERENCE_FILTER} -M crossrefYaml=${CMAKE_CURRENT_SOURCE_DIR}/pandoc-crossref.yaml 
    ARGS      --bibliography=${CMAKE_CURRENT_SOURCE_DIR}/bibliography.bib --citeproc
    ARGS      --template=${CMAKE_CURRENT_SOURCE_DIR}/mfront-template.html
    ARGS      --csl=${CMAKE_CURRENT_SOURCE_DIR}/iso690-numeric-en.csl
    ARGS      --mathjax
    ARGS      --highlight-style=tango
    ARGS      --email-obfuscation=javascript
    ARGS       --default-image-extension=svg
    ARGS      ${ARGN}
    ARGS      ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md -o ${file}.html)
  add_custom_target(${file}-html ALL DEPENDS ${file}.html)
  add_dependencies(website ${file}-html)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
      DESTINATION share/doc/tfel/web
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endmacro(pandoc_html)

add_custom_target(website)
add_dependencies(doc website)

pandoc_html(index "-c css/slideshow.css")
pandoc_html(behaviour-variable)
pandoc_html(initializers)
pandoc_html(post-processings)
pandoc_html(associated-projects "--toc")
pandoc_html(mfront-types "--toc")
pandoc_html(search)
pandoc_html(faq "--toc")
pandoc_html(getting-started "--toc")
pandoc_html(interfaces)
pandoc_html(install "--toc" "--number-sections")
pandoc_html(install-freebsd "-c css/slideshow.css")
pandoc_html(install-windows-msys)
pandoc_html(install-windows-Cast3M2017 "--toc")
pandoc_html(install-windows-VisualStudio)
pandoc_html(packages)
pandoc_html(about)
pandoc_html(contributing)
pandoc_html(libraries_usage  "--toc" "--toc-depth=3")
pandoc_html(mtest)
pandoc_html(mtest-python "--toc" "--toc-depth=3")
pandoc_html(mtest-nonlinear-constraints "--toc" "--toc-depth=3")
pandoc_html(tutorial "--toc" "--toc-depth=3")
pandoc_html(tutorial-spanish  "--toc" "--toc-depth=3")
pandoc_html(benchmark)
pandoc_html(news "-c css/slideshow.css")
pandoc_html(castem)
pandoc_html(castem-fr)
pandoc_html(amitex "-c css/slideshow.css")
pandoc_html(cyrano "--toc" "--toc-depth=1"  "--number-sections")
pandoc_html(aster "--toc" "--toc-depth=1"  "-c css/slideshow.css")
pandoc_html(abaqus "-c css/slideshow.css")
pandoc_html(ansys "-c css/slideshow.css")
pandoc_html(calculix "-c css/slideshow.css")
pandoc_html(zmat)
pandoc_html(documentations)
pandoc_html(gallery  "--toc")
pandoc_html(glossary)
pandoc_html(material-properties "--toc" "--toc-depth=3" "--number-sections")
pandoc_html(behaviours)
pandoc_html(implicit-dsl "--toc" "--toc-depth=3"  "--number-sections")
pandoc_html(models)
pandoc_html(parameters "--toc" "--toc-depth=3"  "--number-sections")
pandoc_html(publications)
pandoc_html(release-notes "--toc" "--toc-depth=1")
pandoc_html(mfront-query "--toc" "--toc-depth=2")
pandoc_html(compiling-mfront-shared-libraries "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(madnex "--toc" "--toc-depth=2")
pandoc_html(math "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(mfm)
pandoc_html(mfm-test-generator)
pandoc_html(mfront-doc)
pandoc_html(tfel-material "--toc" "--toc-depth=2")
pandoc_html(tfel-math "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-math-numerical-integration "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-math-data-interpolation "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-mfront-database "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-check "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(mfront-python "--toc" "--toc-depth=3")
pandoc_html(Taylor "--toc" "--toc-depth=2")
pandoc_html(Sachs "--toc" "--toc-depth=1")
pandoc_html(BetaRule "--toc" "--toc-depth=2")
pandoc_html(Norton-web)
pandoc_html(Norton-full)
pandoc_html(coverity-scan)
pandoc_html(drucker "--toc")
pandoc_html(drucker-prager-cap "--toc")
pandoc_html(hosford "--toc")
pandoc_html(barlat-yld2004 "--toc")
pandoc_html(greenplasticity "--toc")
pandoc_html(hyperelasticity "--toc")
pandoc_html(FeFpImplicitPlasticity "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(signorini "--toc" "--toc-depth=2" "-c css/slideshow.css")
pandoc_html(ogden "--toc" "--toc-depth=2")
pandoc_html(iwan "--toc" "--toc-depth=2")
pandoc_html(hyperviscoelasticity "--toc" "--toc-depth=2")
pandoc_html(BiphasicLinearHomogenization "--toc" "--toc-depth=2")
pandoc_html(IsotropicLinearHardeningPlasticity "--toc" "--toc-depth=2")
pandoc_html(orthotropiclinearhardeningplasticity "--toc" "--toc-depth=2")
pandoc_html(physical-constants)
pandoc_html(isotropicplasticityamstrongfrederickinematichardening "--toc" "--toc-depth=2")
pandoc_html(singlecrystal "--toc" "--toc-depth=2")
pandoc_html(finitestrainsinglecrystal "--toc" "--toc-depth=2")
pandoc_html(finitestrainsinglecrystal-huang "--toc" "--toc-depth=2")
pandoc_html(phasefield "--toc" "--toc-depth=2")
pandoc_html(release-notes-2.0.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0   "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.13 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.14 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.15 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.16 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.1.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.13 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.14 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.15 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.16 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.2.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.13 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.3   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.1   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.2   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.3)
pandoc_html(release-notes-3.3.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.3.5   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.3.6   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.3.7   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.3.8   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.3   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.5   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.6   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.7   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.8   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.9   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.1 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.2 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.3 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.4 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.5 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.6 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.1 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.2 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.3 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.4 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.5 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.1  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.2  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.3  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.4  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.5  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-5.0    "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-5.0.1  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-5.0.2  "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-5.1    "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(theory  "--toc" "--toc-depth=2")
pandoc_html(tensors "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-physical-constants "--toc" "--toc-depth=2")
pandoc_html(tfel-python "--toc" "--toc-depth=3")
pandoc_html(generic-material-property-interface "--toc")
pandoc_html(generic-behaviours-interface "--toc" "--toc-depth=3")
pandoc_html(sovs "--toc" "--toc-depth=2")
pandoc_html(unicode "--toc" "--toc-depth=2")

=== src/Math/CMakeLists.txt ===
set(TFELMath_SOURCES
    MathException.cxx
    LUException.cxx
    QRException.cxx
    Discretization1D.cxx
    StensorConcept.cxx
    TensorConcept.cxx
    RunTimeCheck.cxx
    StridedRandomAccessIterator.cxx
    DifferenceRandomAccessIterator.cxx)

set(TFELMathCubicSpline_SOURCES
    CubicSpline.cxx)

set(TFELMathKriging_SOURCES
    KrigingErrors.cxx
    KrigingUtilities.cxx
    Kriging1D.cxx
    Kriging2D.cxx
    Kriging3D.cxx
    FactorizedKriging1D1D.cxx
    FactorizedKriging1D2D.cxx
    FactorizedKriging1D3D.cxx)

set(TFELMathParser_SOURCES
    ExternalCFunction.cxx
    ExternalCastemFunction.cxx
    ExternalCyranoFunction.cxx
    ExternalFunctionExpr.cxx
    ExternalFunctionExpr2.cxx
    KrigedFunction.cxx
    DifferentiatedFunctionExpr.cxx
    Expr.cxx
    BinaryFunction.cxx
    BinaryOperator.cxx
    LogicalExpr.cxx
    ConditionalExpr.cxx
    ExternalFunction.cxx
    ConstantExternalFunction.cxx
    EvaluatorBase.cxx
    EvaluatorTExpr.cxx
    EvaluatorFunction.cxx
    Evaluator.cxx
    IntegerEvaluator.cxx
    IntegerEvaluatorTExpr.cxx
    Function.cxx
    PowerFunction.cxx
    Negation.cxx
    Number.cxx
    LevenbergMarquardtEvaluatorWrapper.cxx
    LevenbergMarquardtExternalFunctionWrapper.cxx
    Variable.cxx)

tfel_library(TFELMath ${TFELMath_SOURCES})
target_include_directories(TFELMath
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(TFELMath
	PUBLIC TFELException)
if(enable-static)
  target_include_directories(TFELMath-static
      PUBLIC 
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
      $<INSTALL_INTERFACE:include>)
    target_link_libraries(TFELMath-static
        PUBLIC TFELException-static)
endif(enable-static)

tfel_library(TFELMathCubicSpline ${TFELMathCubicSpline_SOURCES})
target_include_directories(TFELMathCubicSpline
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(TFELMathCubicSpline
   PUBLIC tfel::TFELMath
   PUBLIC tfel::TFELException)
if(enable-static)
    target_include_directories(TFELMathCubicSpline-static
      PUBLIC 
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
      $<INSTALL_INTERFACE:include>)
    target_link_libraries(TFELMathCubicSpline-static
        PUBLIC tfel::TFELMath-static
        PUBLIC tfel::TFELException-static)
endif(enable-static)
    
tfel_library(TFELMathKriging ${TFELMathKriging_SOURCES})
target_include_directories(TFELMathKriging
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(TFELMathKriging
    PUBLIC tfel::TFELMath
    PUBLIC tfel::TFELException)
if(enable-static)
    target_include_directories(TFELMathKriging-static
        PUBLIC 
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)
    target_link_libraries(TFELMathKriging-static
        PUBLIC tfel::TFELMath-static
        PUBLIC tfel::TFELException-static)
endif(enable-static)
    
tfel_library(TFELMathParser ${TFELMathParser_SOURCES})
add_dependencies(TFELMathParser TFELMath)
if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  target_compile_definitions(TFELMathParser PUBLIC "TFEL_ARCH64")
else( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  target_compile_definitions(TFELMathParser PUBLIC "TFEL_ARCH32")
endif( CMAKE_SIZEOF_VOID_P EQUAL 8 )
target_include_directories(TFELMathParser
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(TFELMathParser
	PUBLIC tfel::TFELMathKriging
        PUBLIC tfel::TFELMath
	PUBLIC tfel::TFELException
	PUBLIC tfel::TFELUnicodeSupport)
if(enable-static)
    if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
      target_compile_definitions(TFELMathParser-static PUBLIC "TFEL_ARCH64")
    else( CMAKE_SIZEOF_VOID_P EQUAL 8 )
      target_compile_definitions(TFELMathParser-static PUBLIC "TFEL_ARCH32")
    endif( CMAKE_SIZEOF_VOID_P EQUAL 8 )
    target_include_directories(TFELMathParser-static
      PUBLIC 
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/mfront/include>
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
      $<INSTALL_INTERFACE:include>)
    target_link_libraries(TFELMathParser-static
        PUBLIC tfel::TFELMathKriging-static
        PUBLIC tfel::TFELMath-static
        PUBLIC tfel::TFELException-static
        PUBLIC tfel::TFELUnicodeSupport-static)
endif(enable-static)

=== tests/Material/CMakeLists.txt ===
# a simple macro
macro(tests_material test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMaterial>\;$<TARGET_FILE_DIR:TFELNUMODIS>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMaterial TFELMath
    TFELUtilities TFELException TFELTests)
endmacro(tests_material)

tests_material(LinearHomogenizationSchemes)
tests_material(LinearHomogenizationBounds)
tests_material(IsotropicEshelbyTensor)
tests_material(MicrostructureDescription)
tests_material(MicrostructureLinearHomogenization)
tests_material(Lame)
tests_material(IsotropicModuli)
tests_material(AnisotropicEshelbyTensor)
tests_material(boundsCheck)
tests_material(OrthotropicAxesConventionTest)
tests_material(AbaqusTangentOperator)
tests_material(AbaqusTangentOperator2)
tests_material(FiniteStrainBehaviourTangentOperator)
tests_material(FiniteStrainBehaviourTangentOperator2)
tests_material(FiniteStrainBehaviourTangentOperator3)
tests_material(FiniteStrainBehaviourTangentOperator4)
tests_material(FiniteStrainBehaviourTangentOperator5)
tests_material(FiniteStrainBehaviourTangentOperator6)
tests_material(FiniteStrainBehaviourTangentOperator7)
tests_material(FiniteStrainBehaviourTangentOperator8)
tests_material(FiniteStrainBehaviourTangentOperator9)
tests_material(FiniteStrainBehaviourTangentOperator10)
tests_material(FiniteStrainBehaviourTangentOperator11)
tests_material(FiniteStrainBehaviourTangentOperator12)
tests_material(FiniteStrainBehaviourTangentOperator13)
tests_material(FiniteStrainBehaviourTangentOperator14)
tests_material(LogarithmicStrainHandlerTest)
tests_material(Hyperelasticity)
tests_material(Ogden)
tests_material(IsotropicPlasticityTest)
tests_material(OrthotropicPlasticityTest)
tests_material(SlipSystemsDescriptionTest)
tests_material(HosfordSecondDerivativeTest)
tests_material(BarlatSecondDerivativeTest)
tests_material(BarlatSecondDerivativeTest2)
tests_material(IsotropicCazacuYieldTest)
tests_material(LogarithmicStrainComputeAxialStrainIncrementElasticPredictionTest)
tests_material(InverseLangevinFunctionTest)

=== tests/Math/CMakeLists.txt ===
add_subdirectory(ExpressionTemplates)
add_subdirectory(NumericalIntegration)
add_subdirectory(RungeKutta)
add_subdirectory(stensor)
add_subdirectory(tensor)
add_subdirectory(st2tost2)
add_subdirectory(t2tost2)
add_subdirectory(st2tot2)
add_subdirectory(t2tot2)
if(enable-cadna)
  add_subdirectory(cadna)
endif(enable-cadna)

# a simple macro
macro(tests_math test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  target_include_directories(${test_arg}
    PRIVATE ${PROJECT_SOURCE_DIR}/tests/Math/include/)
  target_link_libraries(${test_arg}
    TFELMath TFELUtilities TFELException TFELTests)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
endmacro(tests_math)

macro(tests_math2 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMathKriging>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMathKriging TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_math2)

macro(tests_math3 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMathKriging>\;$<TARGET_FILE_DIR:TFELMathParser>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMathParser TFELMathKriging TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_math3)

macro(tests_math4 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMathCubicSpline>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMathCubicSpline TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_math4)

tests_math(IndexingPoliciesTest)
tests_math(view)
tests_math(coalesced_view)
tests_math(power)
tests_math(CubicRoots)
tests_math(promote)
tests_math(derivative_type)
tests_math(derivative_view)
tests_math(hill)
tests_math(qt)
tests_math(qt2)
tests_math(qt3)
tests_math(qt4)
tests_math(conj)
tests_math(lu)
tests_math(lu2)
tests_math(lu3)
tests_math(invert)
tests_math(invert2)
tests_math(tinymatrixsolve)
tests_math(tinymatrixsolve2)
tests_math(qr)
tests_math(newton_raphson)
tests_math(powell_dog_leg_newton_raphson)
tests_math(solve)
tests_math(fsarray)
tests_math(runtime_array)
tests_math(tmatrix)
tests_math(tmatrix1)
tests_math(tmatrix2)
tests_math(tmatrix4)
tests_math(tmatrix5)
tests_math(tmatrix6)
tests_math(tmatrix7)
tests_math(tvector)
tests_math(tvector2)
tests_math(tvector3)
tests_math(tvector4)
tests_math(tvector5)
tests_math(tvector6)
tests_math(tvector7)
tests_math(VectorResultType)
tests_math(broyden)
tests_math(broyden2)
tests_math(TinyVectorOfStensorFromTinyVectorView)
tests_math(TinyVectorOfTinyVectorFromTinyVectorView)
tests_math(discretization1D)
tests_math(levenberg-marquardt)
tests_math(levenberg-marquardt2)
tests_math(levenberg-marquardt3)
tests_math(levenberg-marquardt5)
tests_math(CorotationnalCauchyStressToSecondPioloKirchhoffStressTest)
tests_math(StridedRandomAccessIteratorTest)
tests_math(DifferenceRandomAccessIteratorTest)
tests_math(IEEE754Test)
tests_math(ScalarNewtonRaphsonTest)
tests_math(BissectionAlgorithmTest)
tests_math(FixedSizeArrayDerivativeTest)
tests_math(ComputeNumericalDerivativeTest)
tests_math(LinearInterpolationTest)
tests_math(CubicSplineInterpolationTest)
tests_math(matrix)
tests_math(types)

tests_math3(levenberg-marquardt4)

tests_math2(krigeage)
tests_math2(krigeage1D)
tests_math2(krigeage2D)

tests_math3(parser)
tests_math3(parser2)
tests_math3(parser3)
tests_math3(parser4)
tests_math3(parser5)
tests_math3(parser6)
tests_math3(parser7)
tests_math3(parser8)
tests_math3(parser9)
tests_math3(parser10)
tests_math3(parser11)
tests_math3(parser12)
tests_math3(integerparser)

tests_math4(CubicSplineTest)

tests_math4(TensorProductCheck)

=== bindings/python/tests/CMakeLists.txt ===
if(TFEL_PYTHON_MODULES_APPEND_SUFFIX)
  set(tfel_system_python_module "tfel_${TFEL_SUFFIX_FOR_PYTHON_MODULES}.system_${TFEL_SUFFIX_FOR_PYTHON_MODULES}")
  set(tfel_material_python_module "tfel_${TFEL_SUFFIX_FOR_PYTHON_MODULES}.material_${TFEL_SUFFIX_FOR_PYTHON_MODULES}")
  set(mfront_python_module "mfront_${TFEL_SUFFIX_FOR_PYTHON_MODULES}")
  set(mtest_python_module "mtest_${TFEL_SUFFIX_FOR_PYTHON_MODULES}")
else(TFEL_PYTHON_MODULES_APPEND_SUFFIX)
  set(tfel_system_python_module "tfel.system")
  set(tfel_material_python_module "tfel.material")
  set(mfront_python_module "mfront")
  set(mtest_python_module "mtest")
endif(TFEL_PYTHON_MODULES_APPEND_SUFFIX)

configure_file(behaviour-constructors.py.in behaviour-constructors.py @ONLY)
configure_file(small-strain-tridimensional-behaviour-wrapper.py.in
               small-strain-tridimensional-behaviour-wrapper.py @ONLY)
configure_file(material-properties.py.in material-properties.py @ONLY)

function(test_pymfront test)
  if(NOT CMAKE_CONFIGURATION_TYPES)
    configure_file(pymfront${test}.py.in
      pymfront${test}.py @ONLY)
    add_test(NAME pymfront${test}_py
      COMMAND ${Python_EXECUTABLE} pymfront${test}.py)
    set_tests_properties(pymfront${test}_py
      PROPERTIES ENVIRONMENT "PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python")
  endif(NOT CMAKE_CONFIGURATION_TYPES)
endfunction(test_pymfront)

function(test_pymfront_mp interface library function)
  if(NOT CMAKE_CONFIGURATION_TYPES)
    add_test(NAME pymfront_material_properties_${interface}_py
      COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/material-properties.py)
    set_property(TEST pymfront_material_properties_${interface}_py
      PROPERTY ENVIRONMENT
      PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python
      MFRONT_MATERIAL_PROPERTY_LIBRARY=${library}
      MFRONT_MATERIAL_PROPERTY_FUNCTION=${function})      
  endif(NOT CMAKE_CONFIGURATION_TYPES)
endfunction(test_pymfront_mp)

function(test_pymtest_bv file library)
  if(NOT CMAKE_CONFIGURATION_TYPES)
    add_test(NAME pymtest_behaviours_${file}_py
      COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/${file}.py)
    set_property(TEST pymtest_behaviours_${file}_py
      PROPERTY ENVIRONMENT
      PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python
      MTEST_BEHAVIOUR_LIBRARY=${library})      
  endif(NOT CMAKE_CONFIGURATION_TYPES)
endfunction(test_pymtest_bv)

if(HAVE_ASTER)
  test_pymfront(test1)
endif(HAVE_ASTER)
test_pymfront(test2)
test_pymfront(test3)

test_pymfront_mp("generic" "$<TARGET_FILE:MFrontMaterialProperties-generic>" "VanadiumAlloy_YoungModulus_SRMA")
test_pymfront_mp("c" "$<TARGET_FILE:MFrontMaterialProperties>" "VanadiumAlloy_YoungModulus_SRMA")
test_pymfront_mp("cxx" "$<TARGET_FILE:MFrontMaterialProperties-cxx>" "VanadiumAlloy_YoungModulus_SRMA")
if(HAVE_FORTRAN)
 test_pymfront_mp("fortran" "$<TARGET_FILE:MFrontMaterialProperties-fortran>" "VanadiumAlloy_YoungModulus_SRMA")
endif(HAVE_FORTRAN)
if(HAVE_CASTEM)
 test_pymfront_mp("castem" "$<TARGET_FILE:MFrontMaterialProperties-castem>" "VanadiumAlloy_YoungModulus_SRMA")
endif(HAVE_CASTEM)

test_pymtest_bv(behaviour-constructors "$<TARGET_FILE:MFrontGenericBehaviours>")
test_pymtest_bv(small-strain-tridimensional-behaviour-wrapper "$<TARGET_FILE:MFrontGenericBehaviours>")

=== docs/mtest/mtest/CMakeLists.txt ===
macro(install_mtest_desc2 file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md
      DESTINATION share/doc/mtest-${TFEL_SUFFIX}/mtest
      COMPONENT mtest)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md
      DESTINATION share/doc/mtest/mtest
      COMPONENT mtest)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mtest_desc2 file)

install_mtest_desc2(CohesiveForce)
install_mtest_desc2(CohesiveForceEpsilon)
install_mtest_desc2(DeformationGradient)
install_mtest_desc2(DeformationGradientEpsilon)
install_mtest_desc2(Event)
install_mtest_desc2(ImposedDeformationGradient)
install_mtest_desc2(ImposedStrain)
install_mtest_desc2(ImposedStress)
install_mtest_desc2(ModellingHypothesis)
install_mtest_desc2(PrintLagrangeMultipliers)
install_mtest_desc2(NonLinearConstraint)
install_mtest_desc2(RotationMatrix)
install_mtest_desc2(Strain)
install_mtest_desc2(StrainEpsilon)
install_mtest_desc2(Stress)
install_mtest_desc2(StressEpsilon)
install_mtest_desc2(Test)

=== mfront/tests/properties/CMakeLists.txt ===
add_subdirectory(interfaces)

function(add_mfront_generated_source lib interface ext file)
  set(mfront_file   "${CMAKE_CURRENT_SOURCE_DIR}/${file}.mfront")
  set(mfront_executable "$<TARGET_FILE:mfront>")
  if("${interface}" STREQUAL "c")
    set(mfront_output "src/${file}.cxx")
  else("${interface}" STREQUAL "c")
    set(mfront_output "src/${file}-${ext}.cxx")
  endif("${interface}" STREQUAL "c")
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(mfront_flags "--debug")
  else(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(mfront_flags "")
  endif(CMAKE_BUILD_TYPE STREQUAL "Debug")
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    add_custom_command(
      OUTPUT  "${mfront_output}"
      COMMAND "set"
      ARGS "PATH=$<TARGET_FILE_DIR:TFELMFront>;\
$<TARGET_FILE_DIR:MFrontLogStream>;\
$<TARGET_FILE_DIR:TFELMaterial>;\
$<TARGET_FILE_DIR:TFELNUMODIS>;\
$<TARGET_FILE_DIR:TFELMathParser>;\
$<TARGET_FILE_DIR:TFELGlossary>;\
$<TARGET_FILE_DIR:TFELSystem>;\
$<TARGET_FILE_DIR:TFELUtilities>;\
$<TARGET_FILE_DIR:TFELException>;\
$<TARGET_FILE_DIR:TFELConfig>;\
$<TARGET_FILE_DIR:TFELUnicodeSupport>;\
%PATH%"
      COMMAND "${mfront_executable}"
      ARGS    "--search-path=${PROJECT_SOURCE_DIR}/mfront/tests/properties"
      ARGS    "${mfront_flags}" "--interface=${interface}" "${mfront_file}"
      DEPENDS mfront
      DEPENDS "${mfront_file}"
      COMMENT "mfront source ${mfront_file}")
    else((CMAKE_HOST_WIN32) AND (NOT MSYS))
    add_custom_command(
      OUTPUT  "${mfront_output}"
      COMMAND "${mfront_executable}"
      ARGS    "--search-path=${PROJECT_SOURCE_DIR}/mfront/tests/properties"
      ARGS    "${mfront_flags}" "--interface=${interface}" "${mfront_file}"
      DEPENDS mfront
      DEPENDS "${mfront_file}"
      COMMENT "mfront source ${mfront_file}")
    if(CMAKE_VERSION AND (${CMAKE_VERSION} GREATER "2.8.2"))
      file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/generation-test")
      add_test(NAME mfront-${file}-${interface}
	COMMAND ${mfront_executable} ${mfront_flags}
	--interface=${interface}
	--search-path=${PROJECT_SOURCE_DIR}/mfront/tests/properties
	${mfront_file}
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/generation-test")
    endif(CMAKE_VERSION AND (${CMAKE_VERSION} GREATER "2.8.2"))
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  set(${lib}_SOURCES ${mfront_output} ${${lib}_SOURCES} PARENT_SCOPE)
endfunction(add_mfront_generated_source)

function(mfront_check_library lib interface ext)
  if(${ARGC} LESS 1)
    message(FATAL_ERROR "mfront_library : no source specified")
  endif(${ARGC} LESS 1)
  foreach(source ${ARGN})
    add_mfront_generated_source(${lib} ${interface} "${ext}" ${source})
  endforeach(source)
  add_library(${lib} EXCLUDE_FROM_ALL
    ${${lib}_SOURCES}
    ${${lib}_ADDITIONAL_SOURCES})
  target_link_libraries(${lib} PRIVATE TFELException)
  set_target_properties(${lib} PROPERTIES
      COMPILE_FLAGS "-DMFRONT_COMPILING")
  add_dependencies(check ${lib})
endfunction(mfront_check_library)

function(mfront_check_module lib interface ext)
  if(${ARGC} LESS 1)
    message(FATAL_ERROR "mfront_library : no source specified")
  endif(${ARGC} LESS 1)
  foreach(source ${ARGN})
    add_mfront_generated_source(${lib} ${interface} "${ext}" ${source})
  endforeach(source)
  add_library(${lib} MODULE EXCLUDE_FROM_ALL
    ${${lib}_SOURCES}
    ${${lib}_ADDITIONAL_SOURCES})
  target_link_libraries(${lib} PRIVATE TFELException)
  set_target_properties(${lib} PROPERTIES
      COMPILE_FLAGS "-DMFRONT_COMPILING")
  add_dependencies(check ${lib})
endfunction(mfront_check_module)

set(mfront_SOURCES
  ErrnoHandlingCheck
  YoungModulusTest
  PoissonRatioTest
  YoungModulusTest_1
  YoungModulusTest_2
  YoungModulusTest_3
  PoissonRatioTest_12
  PoissonRatioTest_23
  PoissonRatioTest_13
  ShearModulusTest_12
  ShearModulusTest_23
  ShearModulusTest_13
  ThermalExpansionCoefficientTest
  ThermalExpansionCoefficientTest2
  ThermalExpansionCoefficientTest_1
  ThermalExpansionCoefficientTest_2
  ThermalExpansionCoefficientTest_3
  VanadiumAlloy_YoungModulus_SRMA
  VanadiumAlloy_PoissonRatio_SRMA
  VanadiumAlloy_ShearModulus_SRMA
  VanadiumAlloy_SpecificHeat_SRMA
  VanadiumAlloy_ThermalExpansion_SRMA
  VanadiumAlloy_ThermalConductivity_SRMA
  Inconel600_YoungModulus
  T91AusteniticSteel_ThermalExpansion_ROUX2007
  T91AusteniticSteel_b_ROUX2007
  T91AusteniticSteel_F_ROUX2007
  T91AusteniticSteel_Kvisc_ROUX2007
  T91AusteniticSteel_Nexp_ROUX2007
  T91AusteniticSteel_Rinf_ROUX2007
  T91AusteniticSteel_YieldStress_ROUX2007
  T91AusteniticSteel_YoungModulus_ROUX2007
  T91MartensiticSteel_b_ROUX2007
  T91MartensiticSteel_C1_ROUX2007
  T91MartensiticSteel_C2_ROUX2007
  T91MartensiticSteel_F_ROUX2007
  T91MartensiticSteel_gamma1_ROUX2007
  T91MartensiticSteel_growth_ROUX2007
  T91MartensiticSteel_Kvisc_ROUX2007
  T91MartensiticSteel_Nexp_ROUX2007
  T91MartensiticSteel_Rinf_ROUX2007
  T91MartensiticSteel_ThermalExpansion_ROUX2007
  T91MartensiticSteel_YieldStress_ROUX2007
  T91MartensiticSteel_YoungModulus_ROUX2007
  LinearDataInterpolationTest
  LinearDataInterpolationTest2
  LinearDataInterpolationTest3
  LinearDataInterpolationTest4
  LinearDataInterpolationTest5
  CubicSplineDataInterpolationTest
  CubicSplineDataInterpolationTest2
  CubicSplineDataInterpolationTest3
  CubicSplineDataInterpolationTest4
  CubicSplineDataInterpolationTest5)

mfront_dependencies(MFrontMaterialProperties-generic
  MaterialLawDSLOptionsTest
  VanadiumAlloy_YoungModulus_SRMA
  VanadiumAlloy_PoissonRatio_SRMA)
mfront_check_module(MFrontMaterialProperties-generic generic "generic" ${mfront_SOURCES})
target_include_directories(MFrontMaterialProperties-generic
  PRIVATE "${PROJECT_SOURCE_DIR}/include"
  PRIVATE "${PROJECT_SOURCE_DIR}/mfront/include"
  PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")

mfront_dependencies(MFrontMaterialProperties
  MaterialLawDSLOptionsTest
  VanadiumAlloy_YoungModulus_SRMA
  VanadiumAlloy_PoissonRatio_SRMA)
mfront_check_library(MFrontMaterialProperties c "" ${mfront_SOURCES})
target_include_directories(MFrontMaterialProperties
  PRIVATE "${PROJECT_SOURCE_DIR}/include"
  PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")

if(HAVE_CASTEM)
  mfront_dependencies(MFrontMaterialProperties-castem
    MaterialLawDSLOptionsTest
    VanadiumAlloy_YoungModulus_SRMA
    VanadiumAlloy_PoissonRatio_SRMA)
  mfront_check_module(MFrontMaterialProperties-castem castem "castem" ${mfront_SOURCES})
  target_include_directories(MFrontMaterialProperties-castem
    PRIVATE "${PROJECT_SOURCE_DIR}/include"
    PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")
  if(WIN32)
    if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
      set_target_properties(MFrontMaterialProperties-castem PROPERTIES LINK_FLAGS "-Wl,--kill-at")
    endif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
  endif(WIN32)
endif(HAVE_CASTEM)

mfront_dependencies(MFrontMaterialProperties-cxx
  MaterialLawDSLOptionsTest
  VanadiumAlloy_YoungModulus_SRMA
  VanadiumAlloy_PoissonRatio_SRMA)
mfront_check_library(MFrontMaterialProperties-cxx cxx cxx ${mfront_SOURCES})
target_include_directories(MFrontMaterialProperties-cxx
  PRIVATE "${PROJECT_SOURCE_DIR}/include"
  PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")
if(WIN32)
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    set_target_properties(MFrontMaterialProperties-cxx PROPERTIES LINK_FLAGS "-Wl,--kill-at")
  endif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
endif(WIN32)

if(HAVE_FORTRAN)
  mfront_dependencies(MFrontMaterialProperties-fortran
    MaterialLawDSLOptionsTest
    VanadiumAlloy_YoungModulus_SRMA
    VanadiumAlloy_PoissonRatio_SRMA)
  mfront_check_library(MFrontMaterialProperties-fortran fortran "fortran" ${mfront_SOURCES})
  target_include_directories(MFrontMaterialProperties-fortran
    PRIVATE "${PROJECT_SOURCE_DIR}/include"
    PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")
  if(WIN32)
    if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
      set_target_properties(MFrontMaterialProperties-fortran PROPERTIES LINK_FLAGS "-Wl,--kill-at")
    endif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
  endif(WIN32)
endif(HAVE_FORTRAN)

add_executable(test-c EXCLUDE_FROM_ALL test-c.c)
target_include_directories(test-c
  PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")
target_link_libraries(test-c MFrontMaterialProperties)
add_test(NAME test-c COMMAND test-c)
add_dependencies(check test-c)
add_dependencies(test-c MFrontMaterialProperties)

add_executable(test-cxx EXCLUDE_FROM_ALL test-cxx.cxx)
target_include_directories(test-cxx
  PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/include")
target_link_libraries(test-cxx MFrontMaterialProperties-cxx
  TFELTests)
add_test(NAME test-cxx COMMAND test-cxx)
add_dependencies(check test-cxx)
add_dependencies(test-cxx MFrontMaterialProperties-cxx)
if((CMAKE_HOST_WIN32) AND (NOT MSYS))
  set_property(TEST test-cxx
               PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELTests>\;$ENV{PATH}")
endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  target_link_libraries(test-cxx "-lgcov")
endif(CMAKE_BUILD_TYPE STREQUAL "Coverage")

if(HAVE_FORTRAN)
  add_executable(test-f EXCLUDE_FROM_ALL test-f.c compute.f)
  add_test(NAME test-f COMMAND test-f)
  add_dependencies(check test-f)
  add_dependencies(test-f MFrontMaterialProperties-fortran)
  target_link_libraries(test-f MFrontMaterialProperties-fortran)
  IF(GNU_FORTRAN_COMPILER)
    if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
      target_link_libraries(test-f "-lgcov")
    endif(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  endif(GNU_FORTRAN_COMPILER)
endif(HAVE_FORTRAN)

=== tests/Math/NumericalIntegration/CMakeLists.txt ===
function(tests_math_numerical_integration test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  target_include_directories(${test_arg}
    PRIVATE ${PROJECT_SOURCE_DIR}/tests/Math/include/)
  target_link_libraries(${test_arg}
    TFELMath TFELUtilities TFELException TFELTests)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
endfunction(tests_math_numerical_integration)

tests_math_numerical_integration(GaussKronrodQuadratureTest)

=== tests/Math/st2tost2/CMakeLists.txt ===
# a simple macro
macro(tests_st2tost2 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  add_dependencies(check ${test_arg})
  target_link_libraries(${test_arg}  TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_st2tost2)

tests_st2tost2(st2tost2)
tests_st2tost2(st2tost2-2)
tests_st2tost2(st2tost2-3)
tests_st2tost2(st2tost2_components)
tests_st2tost2(st2tost2_operations)
tests_st2tost2(ST2toST2FromTinyMatrixView)
tests_st2tost2(ST2toST2FromTinyMatrixView2)
tests_st2tost2(StensorSquareDerivative) 
tests_st2tost2(ST2toST2ChangeBasis)
tests_st2tost2(ST2toST2PushForward)
tests_st2tost2(ConvertToTangentModuliTest)
tests_st2tost2(ConvertLogarithmicStrainTangentOperator)
tests_st2tost2(ComputeDeterminantSecondDerivativeTest)
tests_st2tost2(ComputeDeviatorDeterminantSecondDerivativeTest)
tests_st2tost2(SymmetricStensorProductDerivativeTest)

=== bindings/python/tfel/material/CMakeLists.txt ===
tfel_material_python_module(_material
  material.cxx
  ModellingHypothesis.cxx
  OutOfBoundsPolicy.cxx
  CrystalStructure.cxx
  PiPlane.cxx
  Barlat.cxx
  Hosford.cxx
  IsotropicModuli.cxx)
target_link_libraries(py_tfel_material__material
  PRIVATE TFELMaterial TFELMath TFELException
  ${TFEL_PYTHON_MODULES_PRIVATE_LINK_LIBRARIES})

tfel_material_python_module(homogenization
  homogenization.cxx
  LinearHomogenizationSchemes.cxx
  LinearHomogenizationBounds.cxx
  HillTensors.cxx
  LocalisationTensors.cxx
  Microstructure.cxx
  MicrostructureLinearHomogenization.cxx)
target_link_libraries(py_tfel_material_homogenization
  PRIVATE TFELMaterial TFELMath TFELException
  ${TFEL_PYTHON_MODULES_PRIVATE_LINK_LIBRARIES})

tfel_python_script(tfel/material __init__.py)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=tfel
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.1.0
pkgrel=1
pkgdesc='MFront: a code generation tool dedicated to material knowledge (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
provides=("${MINGW_PACKAGE_PREFIX}-mfront")
depends=("${MINGW_PACKAGE_PREFIX}-gnuplot"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran") )
makedepends=("${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-fortran") )
license=('spdx:GPL-3.0-or-later')
url='https://tfel.sourceforge.io/'
msys2_repository_url='https://github.com/thelfer/tfel'
source=(${msys2_repository_url}/archive/TFEL-${pkgver}/${_realname}-TFEL-${pkgver}.tar.gz)
sha256sums=('1afd98200de332e97e86d109ce0e1aaa8f18cc6c6c81daec3218809509cdfad7')
noextract=("${_realname}-TFEL-${pkgver}.tar.gz")

prepare() {
  tar -xf "${_realname}-TFEL-${pkgver}.tar.gz" || true
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_conf
  case ${MSYSTEM} in
    CLANG*)
      extra_conf+=("-Denable-fortran=OFF");;
    *)
      extra_conf+=("-Denable-fortran=ON");;
  esac

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_BUILD_TYPE=Release \
      -Denable-python=OFF \
      -Denable-python-bindings=OFF \
      -Denable-aster=ON \
      -Denable-abaqus=ON \
      -Denable-ansys=ON \
      -Denable-europlexus=ON \
      -Denable-zmat=ON \
      -Denable-cyrano=ON \
      -Denable-calculix=ON \
      -Denable-comsol=ON \
      -Denable-diana-fea=ON \
      -Denable-lsdyna=ON \
      -Denable-cxx-17=ON \
      -Denable-portable-build=ON \
      -Denable-reference-doc=OFF \
      ${extra_conf} \
      ../${_realname}-TFEL-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" cmake --build . --target install
  install -Dm644 "${srcdir}"/${_realname}-TFEL-${pkgver}/LICENCE-GNU-GPL "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

# vim: ts=2 sw=2 et:
